#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

from distutils.core import setup, Extension
from Cython.Build import cythonize
import getpass
import sys
import shutil
import pathlib

def compile(py_script_folder, py_script_file):

    if getpass.getuser() == 'gareth' and sys.platform == 'win32':
        raise Exception("Check windows folder setup")
        project_root = "C:/Users/gareth/Documents/PhD_Code"
        project_path = pathlib.Path(project_root)  
        destination = project_path / "pyx_win"
    elif getpass.getuser() == 'garethboyes' and sys.platform == "darwin":
        project_root = "/Users/garethboyes/Box Sync/bitbucket/Py3DGeom"
        project_path = pathlib.Path(project_root)  
        destination = project_path / "pyx_os"
    elif getpass.getuser() == 'gareth' and sys.platform == "darwin":
        raise Exception("Check iMac folder setup")
        project_root = "/Users/gareth/bitbucket/Py3DGeom"
        project_path = pathlib.Path(project_root)  
        destination = project_path / "pyx_os"
    elif getpass.getuser() == 'garethboyes' and sys.platform == "win32":
        project_root = "z:/Box Sync/bitbucket/Py3DGeom"
        project_path = pathlib.Path(project_root)  
        destination = project_path / "pyx_win"
        
    py_script_path = project_path / py_script_folder / py_script_file
    
    renamed = py_script_file.replace("_py.py", ".py")
    renamed_path = project_path/ py_script_folder / renamed

    shutil.copy(py_script_path, renamed_path)
    
    cython_script = renamed_path.as_posix()
    script_name = renamed_path.stem
    cd = {'language_level':'3'}
    
    setup(ext_modules=cythonize(cython_script, compiler_directives=cd),
          script_name=script_name,
          script_args=['build_ext', '--build-lib', destination])  
    
    renamed_path.unlink()  

if __name__ == "__main__":
    
    py_script_folder = "src"
    py_script_file = "Py3DGeom_py.py"
    py_script_file2 = "topology_py.py"
    
    compile(py_script_folder, py_script_file)    
    compile(py_script_folder, py_script_file2)   