# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

import numpy as np


def calc_indices(off, sx1, sx2):

    if off >= 0:

        if off > sx1:
            x1m = x1p = x2m = x2p = 0

        elif sx2 >= sx1:

            x1m = off
            x1p = sx1

            x2m = 0
            x2p = sx1 - off

        elif sx1 - off < sx2:

            x2m = 0
            x2p = sx1 - off

            x1m = off
            x1p = sx2 + off

        else:

            x2m = 0
            x2p = sx2

            x1m = off
            x1p = sx2 + off

    if off < 0:
        x1m = 0
        x1p = sx1

        x2m = -off
        x2p = sx2

        if sx2 + off >= sx1:
            x2p = sx1 - off

        else:
            if sx2 + off > 0:
                x1p = sx2 + off
            else:
                x1p = 0

    # print  x1m, x1p, x2m, x2p

    return x1m, x1p, x2m, x2p


def add_array(arr1, arr2, off):

    dim = len(arr1.shape)

    s1 = {}
    s2 = {}

    for n in range(dim):
        s1[n] = arr1.shape[n]
        s2[n] = arr2.shape[n]

    x1m, x1p, x2m, x2p = calc_indices(off[0], s1[0], s2[0])
    y1m, y1p, y2m, y2p = calc_indices(off[1], s1[1], s2[1])
    z1m, z1p, z2m, z2p = calc_indices(off[2], s1[2], s2[2])

    # print arr1[x1m:x1p]
    # print arr2[x2m:x2p]

    arr1[x1m:x1p,
         y1m:y1p,
         z1m:z1p,
         ] += arr2[x2m:x2p,
                   y2m:y2p,
                   z2m:z2p,
                   ]
    return arr1


def or_array(arr1, arr2, off):

    dim = len(arr1.shape)

    s1 = {}
    s2 = {}

    for n in range(dim):
        s1[n] = arr1.shape[n]
        s2[n] = arr2.shape[n]

    x1m, x1p, x2m, x2p = calc_indices(off[0], s1[0], s2[0])
    y1m, y1p, y2m, y2p = calc_indices(off[1], s1[1], s2[1])
    z1m, z1p, z2m, z2p = calc_indices(off[2], s1[2], s2[2])

    # print arr1[x1m:x1p]
    # print arr2[x2m:x2p]

    arr1[x1m:x1p,
         y1m:y1p,
         z1m:z1p,
         ] |= arr2[x2m:x2p,
                   y2m:y2p,
                   z2m:z2p,
                   ]
    return arr1


def tes3():
    for each_off in range(-20, 20, 1):

        off = (each_off, each_off, each_off)
        a = np.ones((10, 10, 10), np.int)
        b = np.ones((3, 3, 3), np.int)

    for each_off in range(-20, 20, 1):

        off = (each_off, each_off, each_off)

        a = np.ones((4, 4, 4), np.int)
        b = np.ones((4, 4, 4), np.int)

    for each_off in range(-20, 20, 1):

        off = (each_off, each_off, each_off)

        a = np.ones((3, 3, 3), np.int)
        b = np.ones((10, 10, 10), np.int)


def tes1():
    for each_off in range(-10, 10, 1):

        off = (each_off, each_off, each_off)

        a = np.ones((10), np.int)
        b = np.ones((3), np.int)

    for each_off in range(-10, 10, 1):

        off = (each_off, each_off, each_off)

        a = np.ones((3), np.int)
        b = np.ones((10), np.int)


