# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

import datetime
import pathlib
import re


def create_folder(pickles, model, tag, override=None):
    today = datetime.date.today()
    SEARCH = re.compile(r"(?P<model>\D*?)(?P<number>\d*?)-(?P<tag>.*)")
    highest_number = 0

    pickles_path = pathlib.Path(pickles)
    month = str(today.year) + "-" + str(today.month)
    day = month + "-" + str(today.day)
    day_path = pickles_path / month / day
    day_path.mkdir(parents=True, exist_ok=True)
    files = day_path.glob(model + "*")

    if override is None:
        for each in files:
            if each.is_dir():
                search = SEARCH.match(each.stem)
                if search:
                    each_model = search.group("model")
                    each_number = int(search.group("number"))
                    # each_res = search.group("tag")
                    if each_model == model:
                        if each_number > highest_number:
                            highest_number = each_number
        number = highest_number + 1
    else:
        number = override
    folder = model + str(number) + "-" + tag
    folder_path = day_path / folder
    folder_path.mkdir(parents=True, exist_ok=True)

    return folder_path

