# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

# Logging
from utils.logging_env import setup_logging, logging, log_debug
log = logging.getLogger(__name__)
setup_logging(log)
if log.getEffectiveLevel() <= 10:
    log_debug = True


def rgb2hex(r, g, b):

    rgb = '#%02X%02X%02X' % (int(r * 255), int(g * 255), int(b * 255))
    return rgb


def palette_generator2(length):

    pal = []

    for val in range(0, length):

        col = val % 10

        if val == 0:
            red = 0
            green = 0
            blue = 1

        elif val == 1:
            red = 1
            green = 0
            blue = 0

        elif col == 0:
            red = 0.619607843137255
            green = 0.00392156862745098
            blue = 0.258823529411765
        elif col == 1:
            red = 0.835294117647059
            green = 0.243137254901961
            blue = 0.309803921568627

        elif col == 2:
            red = 0.956862745098039
            green = 0.427450980392157
            blue = 0.262745098039216

        elif col == 3:
            red = 0.992156862745098
            green = 0.682352941176471
            blue = 0.380392156862745
        elif col == 4:
            red = 0.996078431372549
            green = 0.87843137254902
            blue = 0.545098039215686
        elif col == 5:
            red = 0.901960784313726
            green = 0.96078431372549
            blue = 0.596078431372549
        elif col == 6:
            red = 0.670588235294118
            green = 0.866666666666667
            blue = 0.643137254901961
        elif col == 7:
            red = 0.4
            green = 0.76078431372549
            blue = 0.647058823529412
        elif col == 8:
            red = 0.196078431372549
            green = 0.533333333333333
            blue = 0.741176470588235
        elif col == 9:
            red = 0.368627450980392
            green = 0.309803921568627
            blue = 0.635294117647059

        elif col == 10:
            red = 0.9
            green = 0.9
            blue = 0.9

        pal.append(rgb2hex(red, green, blue))

    return pal


if __name__ == "__main__":

    print(rgb2hex(1, 1, 1))
