# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

from collections import namedtuple


if __name__=="__main__":
    from grid_set import *
    from display_set import *
    from scene_set import *
    from progress_set import *
else:
    from .grid_set import *
    from .display_set import *
    from .scene_set import *
    from .progress_set import *

global_vars = vars()

def get_grid_settings(grid=9):
    s = global_vars['grid'+str(grid)]
    nt = namedtuple("grid_settings", s)(**s)
    return nt, s
    
    
def get_display_settings(display=7):
    s = global_vars['display'+str(display)]
    nt = namedtuple("display_settings", s)(**s)
    return nt , s

def get_scene_settings(scene=9, update=None):
    s = global_vars['scene'+str(scene)]
    if update is not None:    
        s.update(update)
    nt = namedtuple("scene_settings", s)(**s)
    return nt, s

def get_progress_settings(progress=12):
    s = global_vars['progress'+str(progress)]
    nt = namedtuple("progress_settings", s)(**s)
    return nt, s

if __name__=="__main__":
    
    grid_settings = get_grid_settings()
    display_settings = get_display_settings()
    scene_settings = get_scene_settings()
    progress_settings = get_progress_settings()
    print(progress_settings)
    
    scene = 9
    display =7
    grid = 9
    progress = 12    