# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

progress_default = {
    # General
    "parallel": True,

    # ----------------------
    # Load settings
    "load": False,
    "load_folder": False,
    "load_file": False,
    "pickle": False,

    # ----------------------
    # Add scene elements
    "make_scene": True,

    # ----------------------
    # Set up voxel grid
    "make_vox_grid": True,

    # ----------------------
    # Set up voxel group
    "make_vox_group": True,

    # ----------------------
    # Make a hull
    "make_hull": True,
    "voxel_method": "trimesh",
    "hull_buffer": 1,

    # ----------------------
    # Voxelise
    "voxelise": True,
    "trimesh_interior": True,
    "voxel_set_precision": 1e-7,

    # ----------------------
    # Perform Dft
    'dft_factor': 2,

    # ----------------------
    # Build barriers
    "no_barriers": True,
    "barriers_to_build": 99,
    "connect_up": "skimage",
    "adjacency_26": True,
    "barrier_build_method": "dijkstra",
    "skimage": True,
    "barrier_type": "voxel_barrier",

    # ----------------------
    # Build barriers
    "determine_internals": False,


    # ----------------------
    # Remove buffer
    "remove_buffer": True,

    # ----------------------
    # Dilate

    "dilate": False,

    # ----------------------
    # Convert rooms into solids
    'merge': {},
    "make_solid": True,
    "make_supersolid": False,
    "save_supersolid": False,
    "load_supersolid": False,
    "supersolid_file": "",
    "indi_supersolids": False,
    "supersolid_expansion": 0.1,

    # ----------------------
    # Preview rooms

    "preview": False,
    "display_illustration" : False,
    "display": True,

    # ----------------------
    # Form rooms
    "form_room": False,
    "dilate_rooms": False,
    "dilated_voxels_method": False,
    ""

    "sort_rooms": True,

    "check_manifold": False,


    # ----------------------
    # Save output
    "save": False,
    "save_number_override": None,
    "save_to_svg": False,
    "save_to_qb": False,

    # ----------------------
    # Export output

    "export": False,
    "export_table": "",

    # ----------------------
    # Unused

    "edge_voxels": False,
    "determine_adjacenies": False,
    "simple": True,

}


progress12 = progress_default.copy()
progress12.update({
    "voxelise": True,
    # "voxel_method":"pythonocc",
    "make_solid": True,
    "skimage": False,
})

progress13 = progress_default.copy()
progress13.update({
    "simple": True,
    "voxelise": False,
    # "voxel_method":"pythonocc",
    "make_solid": True,
    "barriers_to_build": 2,
    "skimage": False,
})

progress14 = progress_default.copy()
progress14.update({
    "voxelise": True,
    "barriers_to_build": 30,
    "barrier_build_method": "igraph",
    "skimage": False,
})

progress15 = progress_default.copy()
progress15.update({
    "voxelise": True,
    "barriers_to_build": 0,
    "barrier_build_method": "igraph",
    "connect_up": "networkx",
    "make_solid": True,
    "skimage": False,
})

progress16 = progress_default.copy()
progress16.update({
    "voxelise": True,
    "barriers_to_build": 1,
    "skimage": True,
})

progress17 = progress16.copy()
progress17.update({
    "barriers_to_build": 2,
})

progress18 = progress16.copy()
progress18.update({
    "barriers_to_build": 50,
    "hull_buffer": 10,
})

progress19 = progress_default.copy()
progress19.update({
    "load": "all",
    "load_folder": "2019-3-15",
    "load_file": "TwinRooms1-50"
})

progress20 = progress_default.copy()
progress20.update({
    "load": "voxels",
    "load_folder": "2019-3-15",
    "load_file": "TwinRooms1-50"
})

progress21 = progress_default.copy()
progress21.update({
    "load": "all",
    "load_folder": "2019-3-18",
    "load_file": "Broadgate1-200"
})

progress22 = progress_default.copy()
progress22.update({
    "load": "voxels",
    "load_folder": "2019-3-20",
    "load_file": "Broadgate1-100",
    'skimage': True,
    "hull_buffer": 2,
    "barriers_to_build": 99,
})

progress23 = progress22.copy()
progress23.update({
    "skimage": False,
    "barriers_to_build": 2,
    "hull_buffer": 1,
})


progress24 = progress22.copy()
progress24.update({
    "load": "voxels",
    "load_folder": "2019-3-23",
    "load_file": "Broadgate1-50",
    "skimage": True,
    "barriers_to_build": 99,
})

progress25 = progress22.copy()
progress25.update({
    "export": True,
})

progress26 = progress18.copy()
progress26.update({
    "hull_buffer": 2,
    "preview": True,
    "export": True,
})

progress27 = progress26.copy()
progress27.update({
    "hull_buffer": 2,
    "load": "voxels",
    "load_folder": "2019-4-25",
    "load_file": "Broadgate10-100",
})

progress28 = progress26.copy()
progress28.update({
    "load": "all",
    "load_folder": "2019-4-28",
    "load_file": "Broadgate5-50",
})


progress29 = progress18.copy()
progress29.update({
    "preview": True,
    "hull_buffer": 1,
    "save": True,
    "save_to_svg": True,
    'dft_factor': 2.0,
})

progress30 = progress_default.copy()
progress30.update({
    "hull_buffer": 0,
    "barriers_to_build": 0,
    "make_solid": False,
})

progress31 = progress18.copy()
progress31.update({
    "hull_buffer": 2,
    "make_solid": True,
})

progress32 = progress_default.copy()
progress32.update({
    "load": True,
    "load_folder": "2019-8-18",
    "load_file": "Broadgate7-25",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    "make_solid": False,
    "sort_rooms": True,
})

progress33 = progress_default.copy()
progress33.update({

    "load": True,
    "load_folder": "2019-8-18",
    "load_file": "Broadgate7-25",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    "make_solid": True,
    "sort_rooms": True,

    "merge": {11: [14, 28, 30, 64, 67, 68, 69, 63],
              12: [29, 40, 59],
              13: [32, 46, 48, 49, 51, 52, 53, 54, 60],
              14: [33, 44, 47, 50, 62],
              15: [37, 55]},
    'check_manifold': True
})

progress34 = progress_default.copy()
progress34.update({
    "load": True,
    "load_folder": "2019-8-18",
    "load_file": "Broadgate7-25",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    "make_solid": True,
    "sort_rooms": True,

    "merge": {11: [14, 28, 30, 64, 67, 68, 69, 63],
              12: [29, 40, 59],
              13: [32, 46, 48, 49, 51, 52, 53, 54, 60],
              14: [33, 44, 47, 50, 62],
              15: [37, 55]},
    'check_manifold': True,
    'export': False,
    'export_table': "TABLE4"
})


progress35 = progress_default.copy()
progress35.update({
    "make_vox_grid": False,
    "make_scene": True,
    "make_vox_group": False,
    "pickle": False,
    "voxelise": False,
    "make_hull": False,

})

progress36 = progress33.copy()
progress36.update({

    'check_manifold': False,
    'export': False,
    "save_to_svg": True,
})

progress37 = progress33.copy()
progress37.update({

    'check_manifold': False,
    'export': True,
    'export_table': "B20200828_MERGED",
    "save_to_svg": False,
    "display": False,
    "save": True
})

progress38 = progress33.copy()
progress38.update({

    "load": True,
    "load_folder": "2020-8-28",
    "load_file": "Broadgate4-25",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    "make_solid": False,
    'merge': {},
    "sort_rooms": False,
    'check_manifold': False,
    'export': False,
    'export_table': "B20200828_MERGED",
    "save_to_svg": False,
    "display": True,
    "save": False,
})


progress39 = progress33.copy()
progress39.update({

    "load": True,
    "load_folder": "2019-8-18",
    "load_file": "Broadgate6-100",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    "make_solid": False,
    "make_supersolid": True,
    'merge': {},
    "sort_rooms": False,
    'check_manifold': False,
    'export': False,
    'export_table': "B20200828_MERGED",
    "save_to_svg": False,
    "display": True,
    "save": False,
})

progress40 = progress38.copy()
progress40.update({
    "load": True,
    "load_folder": "2020-8-28",
    "load_file": "Broadgate4-25",
    'check_manifold': False,
    "make_supersolid": True,
    "save_supersolid": False,
    "load_supersolid": False,
    "supersolid_file": "",
    "indi_supersolids": True,
    "save": False,
    'export': True,
    'export_table': "B20200908_MANIFOLD_EXP",
})

progress41 = progress_default.copy()
progress41.update({
    # "load" : True,
    # "load_folder" : "2020-10-2",
    # "make_vox_grid" : False,
    # "make_scene" : False,
    # "make_vox_group" : False,
    # "sort_rooms" : False,
    "preview": True,
    "hull_buffer": 2,
    "barriers_to_build": 99,  # Is this still relevant?
    'dft_factor': 2.0,
    # "remove_buffer": False,
    "save_to_svg": True,
    "save": False,

})

progress42 = progress41.copy()
progress42.update({
    'dft_factor': 1.0,
})

progress43 = progress41.copy()
progress43.update({
    'dft_factor': 0.5,
})

progress44 = progress41.copy()
progress44.update({
    'dft_factor': 0.25,
})

progress45 = progress41.copy()
progress45.update({
    'dft_factor': 0.25,
    'save': False,
    "save_to_svg": False,
    "make_supersolid": True,
    "indi_supersolids": True,
})

progress46 = progress_default.copy()
progress46.update({

    "load": True,
    "load_folder": "2020-10-2",
    "load_file": "Broadgate9-25",
    "make_vox_grid": False,
    "make_scene": False,
    "make_vox_group": False,
    # "make_solid" : False,
    "preview": True,
    "hull_buffer": 2,
    'dft_factor': 0.5,
    "make_supersolid": True,
    "indi_supersolids": True,
    'save': False,
    "save_to_svg": False,
    "merge": {11: [14, 28, 30, 64, 67, 68, 69, 63],
              12: [29, 40, 59],
              13: [32, 46, 48, 49, 51, 52, 53, 54, 60],
              14: [33, 44, 47, 50, 62],
              15: [37, 55]
              },
    'export': True,
    'export_table': "B20200907_MANIFOLD",
})

progress47 = progress_default.copy()
progress47.update({
    # "display_illustration": True,
    

})

if __name__ == "__main__":
    print(progress12)
