# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

scene_default = {
    "scene": "empty",
    "offset": (0, 0, 0),
    "multi_surface": False,
    "small_face_precision": 1e-3,
    "room_start": 11,
    "filename": None,
    "table": None,
    "limit": None,
    "pickle": False,
    "load_shape": False
}

scene1 = scene_default.copy()
scene1.update({
    "scene": "TwinRooms",
    "wall_width": 1,
    "height": 6,
    "room_width": 12,
    "wall_offset": 0,
    "wall_y_offset": 0,
    "gap": 1,
    "x_offset": 0,
    "y_offset": 0,
    "z_offset": 0,
    "two_gaps": False,
})

scene9 = scene1.copy()
scene9.update({
    "room_width": 6,
    "gap": 3,
    "x_offset": 0.1,
    "y_offset": 0.1,
    "z_offset": 0.1,
})

scene7 = scene_default.copy()
scene7.update({
    "scene": "Broadgate",
    "load_voxels": "",
    "load_shape": True
})

scene8 = scene_default.copy()
scene8.update({
    "scene": "empty",
    "load_voxels": "",
})

scene10 = scene7.copy()
scene10.update({
    "offset": (83300, 36250, 90),
})

scene11 = scene_default.copy()
scene11.update({
    "scene": "Illustration",
})

scene12 = scene_default.copy()
scene12.update({
    "scene": "Nagel_room",
})

scene13 = scene_default.copy()
scene13.update({
    "scene": "Two_spirited_penguin",
    "load_voxels": "",
    "load_shape": False,
})

scene14 = scene_default.copy()
scene14.update({
    "scene": "Dodgy_shaft",
    "load_voxels": "",
    "load_shape": False,
})

scene15 = scene_default.copy()
scene15.update({
    "scene": "MES_shaft",
    "load_voxels": "",
    "load_shape": False,
})

scene16 = scene_default.copy()
scene16.update({
    "scene": "MES_shaft",
    "load_voxels": "",
    "load_shape": True,
})

scene17 = scene_default.copy()
scene17.update({
    "scene": "cutaway",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})

scene18 = scene_default.copy()
scene18.update({
    "scene": "extruded",
    # "pickle" : True,

    "load_voxels": "",
    "load_shape": True,
    "multi_surface": True,
})

scene19 = scene_default.copy()
scene19.update({
    "scene": "extruded_and_MEP",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})


scene20 = scene_default.copy()
scene20.update({
    "scene": "cutaway_voxels",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})

scene21 = scene_default.copy()
scene21.update({
    "scene": "",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})


scene22 = scene_default.copy()
scene22.update({
    "scene": "MEP",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})

scene23 = scene_default.copy()
scene23.update({
    "scene": "MEP and cutaway",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
})

scene24 = scene_default.copy()
scene24.update({
    "scene": "filename",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
    "filename": " C138-MMD-C-DMA-C101_2-41051",
    "table": "A20201005_MILEEND",
    "limit": None,
})

scene25 = scene_default.copy()
scene25.update({
    "scene": "spaces",
    "load_voxels": "",
    "load_shape": False,
    "multi_surface": True,
    "table": "C20201007_MANIFOLD_EXP_CLIPPED",
    "limit": None,
})

scene26 = scene_default.copy()
scene26.update({
    "scene": "MES_shaft_transparent",
    "load_voxels": "",
    "load_shape": False,
})


if __name__ == "__main__":
    print(scene9)
