# python3
# -*- coding: utf-8 -*-

# Copyright Gareth Boyes, 2021

class Setting:

    def __init__(s, setting_id):

        s.scene = 0
        s.grid = 0
        s.display = 0
        s.progress = 0
        s.display_update = {}
        s.progress_update = {}
        s.scene_update = {}
        s.grid_update = {}

        if setting_id == 1:
            # Ticket Hall
            s.scene = 7
            s.grid = 13
            s.display = 7
            s.progress = 13

        elif setting_id == 2:

            # Two rooms
            s.scene = 9
            s.grid = 10
            s.display = 7
            s.progress = 17

        if setting_id == 3:
            # Ticket Hall
            s.scene = 7
            s.grid = 13
            s.display = 7
            s.progress = 13

        if setting_id == 4:
            # Ticket Hall
            s.scene = 7
            s.grid = 13
            s.display = 7
            s.progress = 18

        if setting_id == 5:
            # Two rooms
            s.scene = 9
            s.grid = 9
            s.display = 7
            s.progress = 17

        if setting_id == 6:
            # Two rooms
            s.scene = 9
            s.grid = 10
            s.display = 7
            s.progress = 17

        if setting_id == 7:
            # Ticket Hall
            s.scene = 7
            s.grid = 13
            s.display = 7
            s.progress = 16

        if setting_id == 8:
            # Two rooms
            s.scene = 9
            s.grid = 9
            s.display = 7
            s.progress = 19  # Load all
            s.progress = 20  # Load voxels

        if setting_id == 9:
            # Two rooms
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 21  # Load all
            s.progress = 22  # Load voxels

        if setting_id == 10:
            # Ticket Hall
            s.scene = 7
            s.grid = 15
            s.display = 7
            s.progress = 24

        if setting_id == 11:
            # Ticket Hall
            s.scene = 7
            s.grid = 16
            s.display = 7
            s.progress = 16

        if setting_id == 12:
            # Ticket Hall
            s.scene = 7
            s.grid = 15
            s.display = 7
            s.progress = 22

        if setting_id == 2019_04_02_01:
            # Twinroom loading
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 20

        if setting_id == 2019_04_02_02:
            # Tickethall loading
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 24

        if setting_id == 2019_04_04_01:
            # Tickethall_100 loading
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 22

        if setting_id == 2019_04_17_01:
            # Tickethall_100 loading
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 22

        if setting_id == 2019_04_18_01:
            # Tickethall_100 loading
            s.scene = "_default"
            s.grid = "_default"
            s.display = "_default"
            s.progress = 25

        if setting_id == 2019_04_25_01:
            # Tickethall_100
            s.scene = 10
            s.grid = 13
            s.display = "_default"
            s.progress = 26

        if setting_id == 2019_04_25_02:
            # Tickethall_100
            s.scene = 10
            s.grid = 13
            s.display = "_default"
            s.progress = 27

        if setting_id == 2019_04_28_01:
            # Tickethall_50
            s.scene = 10
            s.grid = 15
            s.display = "_default"
            s.progress = 26

        if setting_id == 2019_04_28_02:
            # Tickethall_50
            s.scene = 10
            s.grid = 13
            s.display = "_default"
            s.progress = 28

        if setting_id == 2019_05_30_01:
            s.scene = 10  # Tickethall
            s.grid = 13  # sf = 1.0
            s.display = "_default"
            s.progress = 29  # barriers=50, buffer=2

        if setting_id == 2019_06_16_01:
            # TwoRooms
            s.scene = 9
            s.grid = 10
            s.display = "_default"
            s.progress = 16

        if setting_id == 2019_06_19_01:

            s.scene = 11
            s.grid = 17
            s.display = "_default"
            s.progress = 29

        if setting_id == 2019_07_04_01:

            s.scene = 10  # Tickethall
            # s.grid = 15 #sf = 0.5
            s.grid = 13  # sf = 1
            s.display = "_default"
            s.progress = 29  # barriers=50, buffer=2

        if setting_id == 2019_07_09_01:

            s.scene = 10  # Tickethall
            s.grid = 16  # sf = 0.5
            s.display = "_default"
            s.progress = 29  # barriers=50, buffer=2

        if setting_id == 2019_08_06_01:
            s.scene = 9  # TwoRooms
            s.grid = 10
            s.display = "_default"
            s.progress = 29  # barriers=50, buffer=2

        if setting_id == 2019_09_18_01:
            s.scene = 12  # Nagel_Rooms
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 30  # Display only

        if setting_id == 2019_11_06_01:
            s.scene = 11  # Tickethall
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 30  # Display only

        if setting_id == 2019_11_22_01:
            s.scene = 13  # Tickethall geometry demo
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 30  # Display only

        if setting_id == 2019_11_27_01:
            s.scene = 14  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 30  # Display only

        if setting_id == 2020_01_06_01:
            s.scene = 15  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 30  # Display only

        if setting_id == 2020_01_07_01:
            s.scene = 16  # Mile End Shaft geometry demo
            s.grid = 18
            s.display = "_default"
            s.progress = 29  # Barrier 1

        if setting_id == 2020_01_08_01:
            s.scene = 10  # Broadgate
            s.grid = 18
            s.display = "_default"
            s.progress = 32  # Load Broadgate 2019-8-18/Broadgate 7-25

        if setting_id == 2020_01_08_02:
            s.scene = 10  # Broadgate
            s.grid = 18
            s.display = "_default"
            s.progress = 33  # Load Broadgate 2019-8-18/Broadgate 7-25

        if setting_id == 2020_01_08_03:
            s.scene = 10  # Load Broadgate 2019-8-18/Broadgate 7-25
            s.grid = 18
            s.display = "_default"
            s.progress = 34  # Export

        if setting_id == 2020_08_26_01:
            s.scene = 17  # Cutaway
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35  # Display only

        if setting_id == 2020_08_27_01:
            s.scene = 10  # Broadgate
            s.grid = 18
            s.display = "_default"
            s.progress = 36  # Load Broadgate 2019-8-18/Broadgate 7-25

        if setting_id == 2020_08_28_01:
            s.scene = 10  # Broadgate
            s.grid = 18
            s.display = "_default"
            s.progress = 37  # Load Broadgate 2019-8-18/Broadgate 7-25

        if setting_id == 2020_08_28_02:
            s.scene = 10  # Broadgate
            s.grid = 18
            s.display = "_default"
            s.progress = 38  # Load Broadgate 2020-8-28/Broadgate 4-25

        if setting_id == 2020_08_28_03:
            s.scene = 18  # Extruded
            s.grid = "_from_auto"
            s.display = 8
            s.progress = 35

        if setting_id == 2020_08_28_04:
            s.scene = 19  # Extruded
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35

        if setting_id == 2020_09_04_01:
            s.scene = 20  # Cutaway from voxels
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35

        if setting_id == 2020_09_04_02:
            s.scene = 21  # Dilate voxels
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 39

        if setting_id == 2020_09_04_03:  # Executed on 2020_09_04
            s.scene = 22  # MEP
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35

        if setting_id == 2020_09_04_04:  # Executed on 2020_09_04
            s.scene = 23  # MEP and cutaway
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35

        if setting_id == 2020_09_07_01:  # Executed on 2020_09_07
            s.scene = "_default"  # empty
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 39

        if setting_id == 2020_09_07_02:  # Executed on 2020_09_07
            s.scene = 10  # Broadgate
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 40

        if setting_id == 2020_09_15_01:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 13  # sf = 1
            s.display = 9
            s.progress = 41  # df=2, buffer=2
            s.progress_update = {"save_number_override": 1,
                                 "load_file": "Broadgate1-100"}
            s.display_update = {}

        if setting_id == 2020_09_15_02:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 15  # sf = 0.5
            s.display = 9
            s.progress = 41  # df=2, buffer=2
            s.progress_update = {"save_number_override": 2,
                                 "load_file": "Broadgate2-50"}
            s.display_update = {}

        if setting_id == 2020_09_15_03:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 16  # sf = 0.25
            s.display = 9
            s.progress = 41  # df=2, buffer=2
            s.progress_update = {"save_number_override": 3,
                                 "load_file": "Broadgate3-25"}
            s.display_update = {"special_cases": {28: (0.95686275,
                                                       0.42745098,
                                                       0.2627451)}}

        if setting_id == 2020_09_15_04:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 13  # sf = 1
            s.display = 9
            s.progress = 42  # df=1, buffer=2
            s.progress_update = {"save_number_override": 4,
                                 "load_file": "Broadgate4-100"}
            s.display_update = {}

        if setting_id == 2020_09_15_05:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 15  # sf = 0.5
            s.display = 9
            s.progress = 42  # df=1, buffer=2
            s.progress_update = {"save_number_override": 5,
                                 "load_file": "Broadgate5-50"}
            s.display_update = {"special_cases": {31: (0.19607843,
                                                       0.53333333,
                                                       0.74117647)}}

        if setting_id == 2020_09_15_06:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 16  # sf = 0.25
            s.display = 9
            s.progress = 42  # df=1, buffer=2
            s.progress_update = {"save_number_override": 6,
                                 "load_file": "Broadgate6-25"}
            s.display_update = {"special_cases": {24: (0.36862745,
                                                       0.30980392,
                                                       0.63529412)}}

        if setting_id == 2020_09_15_07:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 13  # sf = 1
            s.display = 9
            s.progress = 43  # df=0.5, buffer=2
            s.progress_update = {"save_number_override": 7,
                                 "load_file": "Broadgate7-100"}
            s.display_update = {"special_cases": {18: (0.83529412,
                                                       0.24313725,
                                                       0.30980392)}}

        if setting_id == 2020_09_15_08:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 15  # sf = 0.5
            s.display = 9
            s.progress = 43  # df=0.5, buffer=2
            s.progress_update = {"save_number_override": 8,
                                 "load_file": "Broadgate8-50"}
            s.display_update = {}

        if setting_id == 2020_09_15_09:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 16  # sf = 0.25
            s.display = 9
            s.progress = 43  # df=0.5, buffer=2
            s.progress_update = {"save_number_override": 9,
                                 "load_file": "Broadgate9-25"}
            s.display_update = {"special_cases": {52: (0.19607843,
                                                       0.53333333,
                                                       0.74117647)}}

        if setting_id == 2020_10_01_01:  # Executed on 2020_09_15
            s.scene = 10  # Tickethall
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 44  # df=0.5, buffer=2
            s.display_update = {"special_cases": {30: (0.83529412,
                                                       0.24313725,
                                                       0.30980392)}}

        if setting_id == 2020_10_05_01:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": " C138-MMD-C-DMA-C101_2-41051"}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_02:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": " C138-MMD-C-DMA-C101_1-41052"}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_03:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": ' C121-MMD-C4-DMA-C101-00301'}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_04:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": ' C502-LAO-E-DMA-C101_1-42201'}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_05:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": ' C502-LAO-E-DMA-C101_2-42205'}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_06:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": ' C123-JUL-S-DMA-CR094_SH006-00004'}

            s.grid = 13  # sf = 0.25

            s.display = 10
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_07:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename":
                              ' C123-JUL-A-DMA-CR094_SH006_2-00001'}
            s.grid = 13  # sf = 0.25
            s.display = 10
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_08:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename": ' C123-JUL-S-DMA-CR094_SH006-00007'}
            s.grid = 13  # sf = 0.25
            s.display = 10
            s.progress = 35  # Display only

        if setting_id == 2020_10_05_09:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename":
                              ' C123-JUL-A-DMA-CR094_SH006_Z-31749'}
            s.grid = 13  # sf = 0.25
            s.display = 10
            s.progress = 35  # Display only

        if setting_id == 2020_10_07_01:

            s.scene = 24  # Tickethall
            s.scene_update = {"filename":
                              ' C123-JUL-A-DMA-CR094_SH006_Z-31749'}
            s.grid = 13  # sf = 0.25
            s.display = 9
            s.progress = 35  # Display only

        if setting_id == 2020_10_09_01:
            s.scene = 10  # Tickethall
            s.grid = 16  # sf = 0.25
            s.display = 9
            s.progress = 46  # df=0.5, buffer=2

        if setting_id == 2020_11_13_01:  # Executed on 2020_11_13
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20200828_EXTRUDED'}
            s.grid = "_from_auto"
            s.display = 9
            s.progress = 35

        if setting_id == 2020_11_13_02:  # Executed on 2020_11_13
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'C20201113_AGGREGATED'}
            s.grid = "_from_auto"
            s.display = 9
            s.progress = 35

        if setting_id == 2020_11_13_03:  # Executed on 2020_11_13
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20200907_MANIFOLD'}
            s.grid = "_from_auto"
            s.display = 9
            s.progress = 35

        if setting_id == 2020_11_13_04:  # Executed on 2020_11_13
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20200908_MANIFOLD_EXP'}
            s.grid = "_from_auto"
            s.display = 9
            s.progress = 35

        if setting_id == 2020_11_13_05:  # Executed on 2020_11_13
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'C20201007_MANIFOLD_EXP_CLIPPED'}
            s.grid = "_from_auto"
            s.display = 9
            s.progress = 35

        if setting_id == 2020_11_19_01:  # Executed on 2020_11_19
            s.scene = 15  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.display = "_default"
            s.progress = 35  # Display only

        if setting_id == 2020_11_19_02:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.display = 11
            s.progress = 35  # Display only

        if setting_id == 2020_11_19_03:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.25, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.5}

        if setting_id == 2020_11_20_01:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.scene_update = {'load_shape': False}
            # s.scene_update = {'pickle' : True}
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.5, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 1,
                                 "save": False,
                                 "save_number_override": 1}

        if setting_id == 2020_11_20_02:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.25, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 1,
                                 "save": True,
                                 "save_number_override": 2}

        if setting_id == 2020_11_20_03:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.1, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 1.0,
                                 "save": True,
                                 "save_number_override": 3}

        if setting_id == 2020_11_20_04:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.5, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.5,
                                 "save": True,
                                 "save_number_override": 4}

        if setting_id == 2020_11_20_05:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.25, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.5,
                                 "save": True,
                                 "save_number_override": 5}

        if setting_id == 2020_11_20_06:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.1, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.5,
                                 "save": True,
                                 "save_number_override": 6}

        if setting_id == 2020_11_20_07:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.5, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.25,
                                 "save": True,
                                 "save_number_override": 7}

        if setting_id == 2020_11_20_08:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.25, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.25,
                                 "save": True,
                                 "save_number_override": 8}

        if setting_id == 2020_11_20_09:  # Executed on 2020_11_19
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.1, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.25,
                                 "save": True,
                                 "save_number_override": 9}

        if setting_id == 2020_11_21_01:  # Executed on 2020_11_20
            s.scene = 26  # Mile End Shaft geometry demo
            s.grid = "_from_auto"
            s.grid_update = {'voxel_scale_factor': 0.25, }
            s.display = 11
            s.progress = 41  # Display only
            s.progress_update = {'dft_factor': 0.5,
                                 "load": True,
                                 "load_folder": "2020-11-21",
                                 "save": False,
                                 "save_number_override": 5,
                                 "load_file": "MES_shaft_transparent5-25",
                                 "make_vox_grid": False,
                                 "make_scene": False,
                                 "make_vox_group": False,
                                 "merge": {11: [41, 26],
                                           12: [40, 25],
                                           13: [39, 24],
                                           14: [47],
                                           15: [46],
                                           16: [45],
                                           17: [50],
                                           18: [49],
                                           19: [48],
                                           20: [42, 27],
                                           21: [43, 28],
                                           22: [44, 29],

                                           23: [33],
                                           24: [34],
                                           25: [35],
                                           26: [23],
                                           37: [18],
                                           38: [22, 85],
                                           39: [87, 88],
                                           40: [12, 13],
                                           41: [53, 32, 31, 30],
                                           42: [38],
                                           43: [37],
                                           44: [36],
                                           45: [19, 14, 17, 21,
                                                20, 16, 15, 11],
                                           },
                                 "save_to_svg": False,
                                 "make_supersolid": True,
                                 "indi_supersolids": True,
                                 "export": True,
                                 'export_table': "B20201121_MES_DILATED",
                                 "preview": True,
                                 "dilate_rooms": True,
                                 }
        if setting_id == 2020_12_03_01:  # Executed on 2020_12_03
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20201203_MES_EXTRUDED'}
            s.grid = "_from_auto"
            s.display = 11
            s.progress = 35

        if setting_id == 2020_12_03_02:  # Executed on 2020_12_03
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20201120_MES_MANIFOLD'}
            s.grid = "_from_auto"
            s.display = 11
            s.progress = 35

        if setting_id == 2020_12_03_03:  # Executed on 2020_12_03
            s.scene = 25  # extruded_spaces
            s.scene_update = {"table": 'B20201121_MES_DILATED'}
            s.grid = "_from_auto"
            s.display = 11
            s.progress = 35

        if setting_id == 2021_01_08_01:  # Executed on 2021_01_08

            s.scene = 11  # Illustration
            s.grid = 17
            s.display = 12
            s.progress = 47
