#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os
import json
import logging.config

log_debug = False


def setup_logging(logger, env_key='LOG_CFG'):
    default_level = logging.INFO
    global value
    value = os.getenv(env_key, None)
    if value:
        path = value
    else:
        path = "logging.json"
    if os.path.exists(path):
        with open(path, 'r') as f:
            config = json.load(f)
        logging.config.dictConfig(config)

    else:
        logger.setLevel(level=default_level)
